'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.chebyshev_eval = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../packages/common/logger.cjs');
const printer = (0, debug_1.debug)('chebyshev_eval');
function chebyshev_eval(x, a, n) {
    let b0;
    let b1;
    let b2;
    let i;
    if (n < 1 || n > 1000) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (x < -1.1 || x > 1.1) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    const twox = x * 2;
    b2 = b1 = 0;
    b0 = 0;
    for (i = 1; i <= n; i++) {
        b2 = b1;
        b1 = b0;
        b0 = twox * b1 - b2 + a[n - i];
    }
    return (b0 - b2) * 0.5;
}
exports.chebyshev_eval = chebyshev_eval;