'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rbeta = exports.qbeta = exports.pbeta = exports.dbeta = exports.rbetaOne = void 0;
var dbeta_1 = require('./dbeta.cjs');
var dnbeta_1 = require('./dnbeta.cjs');
var pbeta_1 = require('./pbeta.cjs');
var pnbeta_1 = require('./pnbeta.cjs');
var qbeta_1 = require('./qbeta.cjs');
var qnbeta_1 = require('./qnbeta.cjs');
var rchisq_1 = require('../chi-2/rchisq.cjs');
var rnchisq_1 = require('../chi-2/rnchisq.cjs');
var rbeta_1 = require('./rbeta.cjs');
Object.defineProperty(exports, 'rbetaOne', {
    enumerable: true,
    get: function () {
        return rbeta_1.rbetaOne;
    }
});
var r_func_1 = require('../../r-func.cjs');
function dbeta(x, shape1, shape2, ncp, log = false) {
    if (ncp === undefined) {
        return (0, dbeta_1.dbeta_scalar)(x, shape1, shape2, log);
    } else {
        return (0, dnbeta_1.dnbeta_scalar)(x, shape1, shape2, ncp, log);
    }
}
exports.dbeta = dbeta;
function pbeta(q, shape1, shape2, ncp, lowerTail = true, logP = false) {
    if (ncp === undefined) {
        return (0, pbeta_1.pbeta)(q, shape1, shape2, lowerTail, logP);
    } else {
        return (0, pnbeta_1.pnbeta)(q, shape1, shape2, ncp, lowerTail, logP);
    }
}
exports.pbeta = pbeta;
function qbeta(p, shape1, shape2, ncp, lowerTail = true, logP = false) {
    if (ncp === undefined) {
        return (0, qbeta_1.qbeta)(p, shape1, shape2, lowerTail, logP);
    } else {
        return (0, qnbeta_1.qnbeta)(p, shape1, shape2, ncp, lowerTail, logP);
    }
}
exports.qbeta = qbeta;
function rbeta(n, shape1, shape2, ncp) {
    if (ncp === undefined) {
        return (0, r_func_1.repeatedCall)(n, rbeta_1.rbetaOne, shape1, shape2);
    } else {
        const ar = (0, r_func_1.repeatedCall)(n, rnchisq_1.rnchisqOne, 2 * shape1, ncp);
        const br = (0, r_func_1.repeatedCall)(n, rchisq_1.rchisqOne, 2 * shape2);
        const result = ar.map((a, i) => a / (a + br[i]));
        return result;
    }
}
exports.rbeta = rbeta;