'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rnbinomOne = exports.rnbinom = exports.qnbinom = exports.pnbinom = exports.dnbinom = void 0;
var dnbinom_1 = require('./dnbinom.cjs');
var pnbinom_1 = require('./pnbinom.cjs');
var qnbinom_1 = require('./qnbinom.cjs');
var rnbinom_1 = require('./rnbinom.cjs');
var r_func_1 = require('../../r-func.cjs');
const probAndMuBoth = '"prob" and "mu" both specified';
const probMis = 'argument "prob" is missing, with no default';
function dnbinom(x, size, prob, mu, log = false) {
    if (mu !== undefined && prob !== undefined) {
        throw new TypeError(probAndMuBoth);
    }
    if (mu !== undefined) {
        return (0, dnbinom_1.dnbinom_mu)(x, size, mu, log);
    }
    if (prob === undefined) {
        throw new TypeError(probMis);
    }
    return (0, dnbinom_1.dnbinom)(x, size, prob, log);
}
exports.dnbinom = dnbinom;
function pnbinom(q, size, prob, mu, lowerTail = true, logP = false) {
    if (mu !== undefined && prob !== undefined) {
        throw new TypeError(probAndMuBoth);
    }
    if (mu !== undefined) {
        return (0, pnbinom_1.pnbinom_mu)(q, size, mu, lowerTail, logP);
    }
    if (prob === undefined) {
        throw new TypeError(probMis);
    }
    return (0, pnbinom_1.pnbinom)(q, size, prob, lowerTail, logP);
}
exports.pnbinom = pnbinom;
function qnbinom(p, size, prob, mu, lowerTail = true, logP = false) {
    if (mu !== undefined && prob !== undefined) {
        throw new TypeError(probAndMuBoth);
    }
    if (mu !== undefined) {
        return (0, qnbinom_1.qnbinom_mu)(p, size, mu, lowerTail, logP);
    }
    if (prob === undefined) {
        throw new TypeError(probMis);
    }
    return (0, qnbinom_1.qnbinom)(p, size, prob, lowerTail, logP);
}
exports.qnbinom = qnbinom;
function rnbinom(n, size, prob, mu) {
    if (mu !== undefined && prob !== undefined) {
        throw new TypeError(probAndMuBoth);
    }
    if (mu !== undefined) {
        return (0, r_func_1.repeatedCall64)(n, rnbinom_1.rnbinom_muOne, size, mu);
    }
    if (prob === undefined) {
        throw new TypeError(probMis);
    }
    return (0, r_func_1.repeatedCall64)(n, rnbinom_1.rnbinomOne, size, prob);
}
exports.rnbinom = rnbinom;
function rnbinomOne(size, prob, mu) {
    if (mu !== undefined && prob !== undefined) {
        throw new TypeError(probAndMuBoth);
    }
    if (mu !== undefined) {
        return (0, rnbinom_1.rnbinom_muOne)(size, mu);
    }
    if (prob === undefined) {
        throw new TypeError(probMis);
    }
    return (0, rnbinom_1.rnbinomOne)(size, prob);
}
exports.rnbinomOne = rnbinomOne;