'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rnbinom_muOne = exports.rnbinomOne = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var rgamma_1 = require('../gamma/rgamma.cjs');
var rpois_1 = require('../poisson/rpois.cjs');
const printer_rnbinom = (0, debug_1.debug)('rnbinom');
function rnbinomOne(size, prob) {
    if (!isFinite(size) || !isFinite(prob) || size <= 0 || prob <= 0 || prob > 1) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer_rnbinom, logger_1.lineInfo4);
    }
    return prob === 1 ? 0 : (0, rpois_1.rpoisOne)((0, rgamma_1.rgamma)(size, (1 - prob) / prob));
}
exports.rnbinomOne = rnbinomOne;
const printer_rnbinom_mu = (0, debug_1.debug)('rnbinom_mu');
function rnbinom_muOne(size, mu) {
    if (!isFinite(size) || !isFinite(mu) || size <= 0 || mu < 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer_rnbinom_mu, logger_1.lineInfo4);
    }
    return mu === 0 ? 0 : (0, rpois_1.rpoisOne)((0, rgamma_1.rgamma)(size, mu / size));
}
exports.rnbinom_muOne = rnbinom_muOne;