'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.dcauchy = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
const printer = (0, debug_1.debug)('dcauchy');
function dcauchy(x, location = 0, scale = 1, log = false) {
    if ((0, r_func_1.isNaN)(x) || (0, r_func_1.isNaN)(location) || (0, r_func_1.isNaN)(scale)) {
        return x + location + scale;
    }
    if (scale <= 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    const y = (x - location) / scale;
    return log ? -(0, r_func_1.log)(r_func_1.PI * scale * (1 + y * y)) : 1 / (r_func_1.PI * scale * (1 + y * y));
}
exports.dcauchy = dcauchy;