'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rcauchyOne = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
const printer = (0, debug_1.debug)('rcauchy');
var rng_1 = require('../../rng/index.cjs');
function rcauchyOne(location = 0, scale = 1) {
    const rng = (0, rng_1.globalUni)();
    if (isNaN(location) || !isFinite(scale) || scale < 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (scale === 0 || !isFinite(location)) {
        return location;
    }
    return location + scale * Math.tan(Math.PI * rng.random());
}
exports.rcauchyOne = rcauchyOne;