'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.dexp = void 0;
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var debug_1 = require('@mangos/debug');
const printer = (0, debug_1.debug)('dexp');
function dexp(x, scale, give_log) {
    if (Number.isNaN(x) || Number.isNaN(scale)) {
        return NaN;
    }
    if (scale <= 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (x < 0) {
        return (0, r_func_1.R_D__0)(give_log);
    }
    return give_log ? -x / scale - Math.log(scale) : Math.exp(-x / scale) / scale;
}
exports.dexp = dexp;