'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.pexp = void 0;
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var debug_1 = require('@mangos/debug');
var expm1_1 = require('./expm1.cjs');
const printer = (0, debug_1.debug)('pexp');
function pexp(q, scale, lower_tail, log_p) {
    if (isNaN(q) || isNaN(scale))
        return q + scale;
    if (scale < 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (q <= 0)
        return (0, r_func_1.R_DT_0)(lower_tail, log_p);
    q = -(q / scale);
    return lower_tail ? log_p ? (0, expm1_1.R_Log1_Exp)(q) : -Math.expm1(q) : (0, r_func_1.R_D_exp)(log_p, q);
}
exports.pexp = pexp;