'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.qexp = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var expm1_1 = require('./expm1.cjs');
const printer = (0, debug_1.debug)('qexp');
function qexp(p, scale, lower_tail, log_p) {
    if (isNaN(p) || isNaN(scale))
        return p + scale;
    if (scale < 0)
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    const rc = (0, logger_1.R_Q_P01_check)(log_p, p);
    if (rc !== undefined) {
        return rc;
    }
    if (p === (0, r_func_1.R_DT_0)(lower_tail, log_p))
        return 0;
    return -scale * (0, expm1_1.R_DT_Clog)(lower_tail, log_p, p);
}
exports.qexp = qexp;