'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rexpOne = void 0;
var logger_1 = require('../../../packages/common/logger.cjs');
var debug_1 = require('@mangos/debug');
var sexp_1 = require('./sexp.cjs');
var global_rng_1 = require('../../rng/global-rng.cjs');
const printer = (0, debug_1.debug)('rexp');
function rexpOne(rate) {
    const rng = (0, global_rng_1.globalUni)();
    if (rate === Infinity || isNaN(rate) || rate <= 0) {
        if (rate === Infinity || rate === -Infinity)
            return 0;
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    return (0, sexp_1.exp_rand)(rng) / rate;
}
exports.rexpOne = rexpOne;