'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rfOne = exports.rf = exports.qf = exports.pf = exports.df = void 0;
var rchisq_1 = require('../chi-2/rchisq.cjs');
var rnchisq_1 = require('../chi-2/rnchisq.cjs');
var r_func_1 = require('../../r-func.cjs');
var df_1 = require('./df.cjs');
var dnf_1 = require('./dnf.cjs');
var pf_1 = require('./pf.cjs');
var pnf_1 = require('./pnf.cjs');
var qf_1 = require('./qf.cjs');
var qnf_1 = require('./qnf.cjs');
var rf_1 = require('./rf.cjs');
function df(x, df1, df2, ncp, log = false) {
    if (ncp === undefined) {
        return (0, df_1.df)(x, df1, df2, log);
    }
    return (0, dnf_1.dnf)(x, df1, df2, ncp, log);
}
exports.df = df;
function pf(q, df1, df2, ncp, lowerTail = true, logP = false) {
    if (ncp === undefined) {
        return (0, pf_1.pf)(q, df1, df2, lowerTail, logP);
    }
    return (0, pnf_1.pnf)(q, df1, df2, ncp, lowerTail, logP);
}
exports.pf = pf;
function qf(p, df1, df2, ncp, lowerTail = true, logP = false) {
    if (ncp === undefined) {
        return (0, qf_1.qf)(p, df1, df2, lowerTail, logP);
    }
    return (0, qnf_1.qnf)(p, df1, df2, ncp, lowerTail, logP);
}
exports.qf = qf;
function rf(n, df1, df2, ncp) {
    if (ncp === undefined) {
        return (0, r_func_1.repeatedCall64)(n, rf_1.rfOne, df1, df2);
    }
    if (isNaN(ncp) || isNaN(df1) || isNaN(df2) || !isFinite(df1) || !isFinite(df2)) {
        return (0, r_func_1.repeatedCall64)(n, () => NaN);
    }
    const noms = (0, r_func_1.repeatedCall64)(n, () => (0, rnchisq_1.rnchisqOne)(df1, ncp) / df1);
    for (let i = 0; i < noms.length; i++) {
        const dom = (0, rchisq_1.rchisqOne)(df2) / df2;
        noms[i] = noms[i] / dom;
    }
    return noms;
}
exports.rf = rf;
function rfOne(df1, df2, ncp) {
    if (ncp === undefined) {
        return (0, rf_1.rfOne)(df1, df2);
    }
    if (isNaN(ncp) || isNaN(df1) || isNaN(df2) || !isFinite(df1) || !isFinite(df2)) {
        return NaN;
    }
    const nom = (0, rnchisq_1.rnchisqOne)(df1, ncp) / df1;
    const dom = (0, rchisq_1.rchisqOne)(df2) / df2;
    return nom / dom;
}
exports.rfOne = rfOne;