'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.qnf = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var qnbeta_1 = require('../beta/qnbeta.cjs');
var qnchisq_1 = require('../chi-2/qnchisq.cjs');
const printer = (0, debug_1.debug)('qnf');
function qnf(p, df1, df2, ncp, lowerTail, logP) {
    if (isNaN(p) || isNaN(df1) || isNaN(df2) || isNaN(ncp))
        return p + df1 + df2 + ncp;
    if (df1 <= 0 || df2 <= 0 || ncp < 0 || !isFinite(ncp) || !isFinite(df1) && !isFinite(df2)) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    const rc = (0, logger_1.R_Q_P01_boundaries)(lowerTail, logP, p, 0, Infinity);
    if (rc !== undefined) {
        return rc;
    }
    if (df2 > 100000000)
        return (0, qnchisq_1.qnchisq)(p, df1, ncp, lowerTail, logP) / df1;
    const y = (0, qnbeta_1.qnbeta)(p, df1 / 2, df2 / 2, ncp, lowerTail, logP);
    return y / (1 - y) * (df2 / df1);
}
exports.qnf = qnf;