'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rfOne = void 0;
var debug_1 = require('@mangos/debug');
var rchisq_1 = require('../chi-2/rchisq.cjs');
var logger_1 = require('../../../packages/common/logger.cjs');
const printer = (0, debug_1.debug)('rf');
function rfOne(n1, n2) {
    if (isNaN(n1) || isNaN(n2) || n1 <= 0 || n2 <= 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    const v1 = isFinite(n1) ? (0, rchisq_1.rchisqOne)(n1) / n1 : 1;
    const v2 = isFinite(n2) ? (0, rchisq_1.rchisqOne)(n2) / n2 : 1;
    return v1 / v2;
}
exports.rfOne = rfOne;