'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rgammaOne = exports.rgamma = exports.pgamma = exports.qgamma = exports.dgamma = void 0;
var dgamma_1 = require('./dgamma.cjs');
var pgamma_1 = require('./pgamma.cjs');
var qgamma_1 = require('./qgamma.cjs');
var rgamma_1 = require('./rgamma.cjs');
var r_func_1 = require('../../r-func.cjs');
function gammaNormalizeParams(rate, scale) {
    if (scale === undefined) {
        if (rate === undefined) {
            return 1;
        }
        return 1 / rate;
    }
    if (rate === undefined) {
        return scale;
    }
    throw new TypeError('specify \'rate\' or \'scale\' but not both');
}
function dgamma(x, shape, rate, scale, log = false) {
    const _scale = gammaNormalizeParams(rate, scale);
    return (0, dgamma_1.dgamma)(x, shape, _scale, log);
}
exports.dgamma = dgamma;
function qgamma(p, shape, rate, scale, lowerTail = true, logP = false) {
    const _scale = gammaNormalizeParams(rate, scale);
    return (0, qgamma_1.qgamma)(p, shape, _scale, lowerTail, logP);
}
exports.qgamma = qgamma;
function pgamma(q, shape, rate, scale, lowerTail = true, logP = false) {
    const _scale = gammaNormalizeParams(rate, scale);
    return (0, pgamma_1.pgamma)(q, shape, _scale, lowerTail, logP);
}
exports.pgamma = pgamma;
function rgamma(n, shape, rate, scale) {
    const _scale = gammaNormalizeParams(rate, scale);
    return (0, r_func_1.repeatedCall64)(n, rgamma_1.rgamma, shape, _scale);
}
exports.rgamma = rgamma;
function rgammaOne(shape, rate, scale) {
    const _scale = gammaNormalizeParams(rate, scale);
    return (0, rgamma_1.rgamma)(shape, _scale);
}
exports.rgammaOne = rgammaOne;