'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.qgeom = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var expm1_1 = require('../exp/expm1.cjs');
var r_func_1 = require('../../r-func.cjs');
const printer = (0, debug_1.debug)('qgeom');
function qgeom(p, prob, lowerTail = true, logP = false) {
    if (isNaN(p) || isNaN(prob))
        return NaN;
    if (prob <= 0 || prob > 1) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    const chk1 = (0, logger_1.R_Q_P01_check)(logP, p);
    if (chk1 !== undefined) {
        return chk1;
    }
    if (prob === 1)
        return 0;
    const chk2 = (0, logger_1.R_Q_P01_boundaries)(lowerTail, logP, p, 0, Infinity);
    if (chk2 !== undefined) {
        return chk2;
    }
    return (0, r_func_1.max)(0, (0, r_func_1.ceil)((0, expm1_1.R_DT_Clog)(lowerTail, logP, p) / (0, r_func_1.log1p)(-prob) - 1 - 1e-12));
}
exports.qgeom = qgeom;