'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rgeomOne = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var sexp_1 = require('../exp/sexp.cjs');
var rpois_1 = require('../poisson/rpois.cjs');
var global_rng_1 = require('../../rng/global-rng.cjs');
const printer = (0, debug_1.debug)('rgeom');
function rgeomOne(p) {
    const rng = (0, global_rng_1.globalUni)();
    if (!isFinite(p) || p <= 0 || p > 1)
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    return (0, rpois_1.rpoisOne)((0, sexp_1.exp_rand)(rng) * ((1 - p) / p));
}
exports.rgeomOne = rgeomOne;