'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.dlogis = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
const printer_dlogis = (0, debug_1.debug)('dlogis');
function dlogis(x, location = 0, scale = 1, log = false) {
    if (isNaN(x) || isNaN(location) || isNaN(scale))
        return NaN;
    if (scale <= 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer_dlogis, logger_1.lineInfo4);
    }
    x = (0, r_func_1.abs)((x - location) / scale);
    const e = (0, r_func_1.exp)(-x);
    const f = 1 + e;
    return log ? -(x + (0, r_func_1.log)(scale * f * f)) : e / (scale * f * f);
}
exports.dlogis = dlogis;