'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.plogis = exports.Rf_log1pexp = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
function Rf_log1pexp(x) {
    if (x <= 18)
        return Math.log1p(Math.exp(x));
    if (x > 33.3)
        return x;
    return x + Math.exp(-x);
}
exports.Rf_log1pexp = Rf_log1pexp;
const printer_plogis = (0, debug_1.debug)('plogis');
function plogis(x, location = 0, scale = 1, lowerTail = true, logP = false) {
    if (isNaN(x) || isNaN(location) || isNaN(scale))
        return NaN;
    if (scale <= 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer_plogis, logger_1.lineInfo4);
    }
    x = (x - location) / scale;
    const rc = (0, r_func_1.R_P_bounds_Inf_01)(lowerTail, logP, x);
    if (rc !== undefined) {
        return rc;
    }
    if (logP) {
        return -Rf_log1pexp(lowerTail ? -x : x);
    }
    return 1 / (1 + Math.exp(lowerTail ? -x : x));
}
exports.plogis = plogis;