'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.qlogis = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var expm1_1 = require('../exp/expm1.cjs');
const printer_qlogis = (0, debug_1.debug)('qlogis');
function qlogis(p, location = 0, scale = 1, lowerTail = true, logP = false) {
    if (isNaN(p) || isNaN(location) || isNaN(scale))
        return NaN;
    const rc = (0, logger_1.R_Q_P01_boundaries)(lowerTail, logP, p, -Infinity, Infinity);
    if (rc !== undefined) {
        return rc;
    }
    if (scale < 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer_qlogis, logger_1.lineInfo4);
    }
    if (scale === 0)
        return location;
    if (logP) {
        if (lowerTail)
            p = p - (0, expm1_1.R_Log1_Exp)(p);
        else
            p = (0, expm1_1.R_Log1_Exp)(p) - p;
    } else
        p = (0, r_func_1.log)(lowerTail ? p / (1 - p) : (1 - p) / p);
    return location + scale * p;
}
exports.qlogis = qlogis;