'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rlogisOne = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var rng_1 = require('../../rng/index.cjs');
const printer_rlogis = (0, debug_1.debug)('rlogis');
function rlogisOne(location = 0, scale = 1) {
    const rng = (0, rng_1.globalUni)();
    if (isNaN(location) || !isFinite(scale)) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer_rlogis, logger_1.lineInfo4);
    }
    if (scale === 0 || !isFinite(location))
        return location;
    else {
        const u = rng.random();
        return location + scale * Math.log(u / (1 - u));
    }
}
exports.rlogisOne = rlogisOne;