'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.dlnorm = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
const printer = (0, debug_1.debug)('dlnorm');
function dlnorm(x, meanlog = 0, sdlog = 1, log = false) {
    if (isNaN(x) || isNaN(meanlog) || isNaN(sdlog)) {
        return x + meanlog + sdlog;
    }
    if (sdlog <= 0) {
        if (sdlog < 0) {
            return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
        }
        return Math.log(x) === meanlog ? Infinity : (0, r_func_1.R_D__0)(log);
    }
    if (x <= 0) {
        return (0, r_func_1.R_D__0)(log);
    }
    const y = ((0, r_func_1.log)(x) - meanlog) / sdlog;
    return log ? -(r_func_1.M_LN_SQRT_2PI + 0.5 * y * y + (0, r_func_1.log)(x * sdlog)) : r_func_1.M_1_SQRT_2PI * Math.exp(-0.5 * y * y) / (x * sdlog);
}
exports.dlnorm = dlnorm;