'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.plnorm = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var pnorm_1 = require('../normal/pnorm.cjs');
const printer = (0, debug_1.debug)('plnorm');
function plnorm(q, meanlog = 0, sdlog = 1, lowerTail = true, logP = false) {
    if ((0, r_func_1.isNaN)(q) || (0, r_func_1.isNaN)(meanlog) || (0, r_func_1.isNaN)(sdlog))
        return q + meanlog + sdlog;
    if (sdlog < 0)
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    if (q > 0)
        return (0, pnorm_1.pnorm5)((0, r_func_1.log)(q), meanlog, sdlog, lowerTail, logP);
    return (0, r_func_1.R_DT_0)(lowerTail, logP);
}
exports.plnorm = plnorm;