'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.qlnorm = void 0;
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var qnorm_1 = require('../normal/qnorm.cjs');
function qlnorm(p, meanlog = 0, sdlog = 1, lowerTail = true, logP = false) {
    if (isNaN(p) || isNaN(meanlog) || isNaN(sdlog))
        return p + meanlog + sdlog;
    const rc = (0, logger_1.R_Q_P01_boundaries)(lowerTail, logP, p, 0, Infinity);
    if (rc !== undefined) {
        return rc;
    }
    return (0, r_func_1.exp)((0, qnorm_1.qnorm)(p, meanlog, sdlog, lowerTail, logP));
}
exports.qlnorm = qlnorm;