'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.pnorm5 = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var pnorm_both_1 = require('./pnorm_both.cjs');
const printer = (0, debug_1.debug)('pnorm');
var NumberW_1 = require('../../common/toms708/NumberW.cjs');
function pnorm5(q, mean = 0, sd = 1, lowerTail = true, logP = false) {
    if (isNaN(q) || isNaN(mean) || isNaN(sd))
        return NaN;
    if (!isFinite(q) && mean === q)
        return NaN;
    if (sd <= 0) {
        if (sd < 0)
            return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
        return q < mean ? (0, r_func_1.R_DT_0)(lowerTail, logP) : (0, r_func_1.R_DT_1)(lowerTail, logP);
    }
    const p = new NumberW_1.NumberW(0);
    const cp = new NumberW_1.NumberW(0);
    p.val = (q - mean) / sd;
    if (!isFinite(p.val))
        return q < mean ? (0, r_func_1.R_DT_0)(lowerTail, logP) : (0, r_func_1.R_DT_1)(lowerTail, logP);
    q = p.val;
    (0, pnorm_both_1.pnorm_both)(q, p, cp, !lowerTail, logP);
    return lowerTail ? p.val : cp.val;
}
exports.pnorm5 = pnorm5;