'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.pnorm_both = void 0;
var do_del_1 = require('./do_del.cjs');
var r_func_1 = require('../../r-func.cjs');
const {
    EPSILON: DBL_EPSILON,
    MIN_VALUE: DBL_MIN
} = Number;
function pnorm_both(x, cum, ccum, i_tail, log_p) {
    const a = [
        2.2352520354606837,
        161.02823106855587,
        1067.6894854603709,
        18154.98125334356,
        0.06568233791820745
    ];
    const b = [
        47.202581904688245,
        976.0985517377767,
        10260.932208618979,
        45507.78933502673
    ];
    const c = [
        0.39894151208813466,
        8.883149794388377,
        93.50665613217785,
        597.2702763948002,
        2494.5375852903726,
        6848.190450536283,
        11602.65143764735,
        9842.714838383978,
        1.0765576773720192e-8
    ];
    const d = [
        22.266688044328117,
        235.387901782625,
        1519.3775994075547,
        6485.558298266761,
        18615.571640885097,
        34900.95272114598,
        38912.00328609327,
        19685.429676859992
    ];
    const p = [
        0.215898534057957,
        0.12740116116024736,
        0.022235277870649807,
        0.0014216191932278934,
        0.000029112874951168793,
        0.023073441764940174
    ];
    const q = [
        1.284260096144911,
        0.4682382124808651,
        0.06598813786892856,
        0.0037823963320275824,
        0.00007297515550839662
    ];
    let xden;
    let xnum;
    let temp;
    let xsq;
    const min = DBL_MIN;
    const eps = DBL_EPSILON * 0.5;
    const lower = i_tail !== true;
    const upper = i_tail !== false;
    const y = Math.abs(x);
    if (y <= 0.67448975) {
        if (y > eps) {
            xsq = x * x;
            xnum = a[4] * xsq;
            xden = xsq;
            for (let i = 0; i < 3; ++i) {
                xnum = (xnum + a[i]) * xsq;
                xden = (xden + b[i]) * xsq;
            }
        } else {
            xnum = xden = 0;
        }
        temp = x * (xnum + a[3]) / (xden + b[3]);
        if (lower)
            cum.val = 0.5 + temp;
        if (upper)
            ccum.val = 0.5 - temp;
        if (log_p) {
            if (lower)
                cum.val = Math.log(cum.val);
            if (upper)
                ccum.val = Math.log(ccum.val);
        }
    } else if (y <= r_func_1.M_SQRT_32) {
        xnum = c[8] * y;
        xden = y;
        for (let i = 0; i < 7; ++i) {
            xnum = (xnum + c[i]) * y;
            xden = (xden + d[i]) * y;
        }
        temp = (xnum + c[7]) / (xden + d[7]);
        (0, do_del_1.do_del)(ccum, cum, log_p, y, temp, upper, lower, x);
        if (x > 0) {
            temp = cum.val;
            if (lower) {
                cum.val = ccum.val;
            }
            ccum.val = temp;
        }
    } else if (log_p && y < 1e+170 || lower && -37.5193 < x && x < 8.2924 || upper && -8.2924 < x && x < 37.5193) {
        xsq = 1 / (x * x);
        xnum = p[5] * xsq;
        xden = xsq;
        for (let i = 0; i < 4; ++i) {
            xnum = (xnum + p[i]) * xsq;
            xden = (xden + q[i]) * xsq;
        }
        temp = xsq * (xnum + p[4]) / (xden + q[4]);
        temp = (r_func_1.M_1_SQRT_2PI - temp) / y;
        (0, do_del_1.do_del)(ccum, cum, log_p, x, temp, upper, lower, x);
        if (x > 0) {
            temp = cum.val;
            if (lower) {
                cum.val = ccum.val;
            }
            ccum.val = temp;
        }
    } else {
        if (x > 0) {
            cum.val = (0, r_func_1.R_D__1)(log_p);
            ccum.val = (0, r_func_1.R_D__0)(log_p);
        } else {
            cum.val = (0, r_func_1.R_D__0)(log_p);
            ccum.val = (0, r_func_1.R_D__1)(log_p);
        }
    }
    if (log_p) {
        if (cum.val > -min)
            cum.val = -0;
        if (ccum.val > -min) {
            ccum.val = -0;
        }
    } else {
        if (cum.val < min)
            cum.val = 0;
        if (ccum.val < min)
            ccum.val = 0;
    }
    return;
}
exports.pnorm_both = pnorm_both;