'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rnormOne = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var global_rng_1 = require('../../rng/global-rng.cjs');
const printer = (0, debug_1.debug)('rnorm');
function rnormOne(mean = 0, sd = 1) {
    const rng = (0, global_rng_1.globalNorm)();
    if (isNaN(mean) || !isFinite(sd) || sd < 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (sd === 0 || !isFinite(mean)) {
        return mean;
    }
    return mean + sd * rng.random();
}
exports.rnormOne = rnormOne;