'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.cpu_csignrank = void 0;
var r_func_1 = require('../../r-func.cjs');
var csignrank_wasm_1 = require('./csignrank_wasm.cjs');
const get64View = () => new Float64Array(csignrank_wasm_1.memory.buffer);
function cpu_csignrank(k, n, u, c) {
    const w = get64View();
    if (k < 0 || k > u)
        return 0;
    if (k > c)
        k = u - k;
    if (n === 1)
        return 1;
    if (w[0] === 1)
        return w[k];
    w[0] = w[1] = 1;
    for (let j = 2; j < n + 1; ++j) {
        let i;
        const end = (0, r_func_1.imin2)(j * (j + 1) / 2, c);
        for (i = end; i >= j; --i) {
            w[i] += w[i - j];
        }
    }
    return w[k];
}
exports.cpu_csignrank = cpu_csignrank;