'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rsignrankOne = exports.clearBackendSignRank = exports.useWasmBackendSignRank = exports.rsignrank = exports.qsignrank = exports.psignrank = exports.dsignrank = void 0;
var dsign_1 = require('./dsign.cjs');
Object.defineProperty(exports, 'dsignrank', {
    enumerable: true,
    get: function () {
        return dsign_1.dsignrank;
    }
});
var psign_1 = require('./psign.cjs');
Object.defineProperty(exports, 'psignrank', {
    enumerable: true,
    get: function () {
        return psign_1.psignrank;
    }
});
var qsign_1 = require('./qsign.cjs');
Object.defineProperty(exports, 'qsignrank', {
    enumerable: true,
    get: function () {
        return qsign_1.qsignrank;
    }
});
var dsign_2 = require('./dsign.cjs');
var qsign_2 = require('./qsign.cjs');
var psign_2 = require('./psign.cjs');
var rsign_1 = require('./rsign.cjs');
Object.defineProperty(exports, 'rsignrankOne', {
    enumerable: true,
    get: function () {
        return rsign_1.rsignrankOne;
    }
});
var r_func_1 = require('../../r-func.cjs');
var csignrank_wasm_1 = require('./csignrank_wasm.cjs');
function rsignrank(nn, n) {
    return (0, r_func_1.repeatedCall64)(nn, rsign_1.rsignrankOne, n);
}
exports.rsignrank = rsignrank;
function useWasmBackendSignRank() {
    const fns = (0, csignrank_wasm_1.initWasm)();
    (0, dsign_2.registerBackend)(fns);
    (0, qsign_2.registerBackend)(fns);
    (0, psign_2.registerBackend)(fns);
}
exports.useWasmBackendSignRank = useWasmBackendSignRank;
function clearBackendSignRank() {
    let rc = 0;
    if ((0, dsign_2.unRegisterBackend)()) {
        rc++;
    }
    if ((0, qsign_2.unRegisterBackend)()) {
        rc++;
    }
    if ((0, psign_2.unRegisterBackend)()) {
        rc++;
    }
    return rc === 3 ? true : false;
}
exports.clearBackendSignRank = clearBackendSignRank;