'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rsignrankOne = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var global_rng_1 = require('../../rng/global-rng.cjs');
var r_func_1 = require('../../r-func.cjs');
const printer = (0, debug_1.debug)('rsignrank');
function rsignrankOne(n) {
    const rng = (0, global_rng_1.globalUni)();
    if ((0, r_func_1.isNaN)(n)) {
        return n;
    }
    if (n > r_func_1.INT_MAX)
        return 0;
    n = (0, r_func_1.round)(n);
    if (n < 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (n === 0) {
        return 0;
    }
    let r = 0;
    const k = (0, r_func_1.trunc)(n);
    for (let i = 0; i < k;) {
        r += ++i * (0, r_func_1.floor)(rng.random() + 0.5);
    }
    return r;
}
exports.rsignrankOne = rsignrankOne;