'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rtOne = exports.rt = exports.qt = exports.pt = exports.dt = void 0;
var chi_2_1 = require('../chi-2/index.cjs');
var normal_1 = require('../normal/index.cjs');
var rt_1 = require('./rt.cjs');
Object.defineProperty(exports, 'rtOne', {
    enumerable: true,
    get: function () {
        return rt_1.rtOne;
    }
});
var dnt_1 = require('./dnt.cjs');
var pnt_1 = require('./pnt.cjs');
var qnt_1 = require('./qnt.cjs');
var qt_1 = require('./qt.cjs');
var r_func_1 = require('../../r-func.cjs');
function dt(x, df, ncp = 0, log = false) {
    return (0, dnt_1.dnt)(x, df, ncp, log);
}
exports.dt = dt;
function pt(q, df, ncp = 0, lowerTail = true, logP = false) {
    return (0, pnt_1.pnt)(q, df, ncp, lowerTail, logP);
}
exports.pt = pt;
function qt(p, df, ncp, lowerTail = true, logP = false) {
    return ncp === undefined ? (0, qt_1.qt)(p, df, lowerTail, logP) : (0, qnt_1.qnt)(p, df, ncp, lowerTail, logP);
}
exports.qt = qt;
function rt(n, df, ncp) {
    if (ncp === undefined) {
        return (0, r_func_1.repeatedCall64)(n, rt_1.rtOne, df);
    } else {
        const norm = (0, normal_1.rnorm)(n, ncp, 1);
        const chisq = (0, chi_2_1.rchisq)(n, df, undefined);
        for (let i = 0; i < n; i++) {
            chisq[i] /= df;
            chisq[i] = (0, r_func_1.sqrt)(chisq[i]);
            norm[i] /= chisq[i];
        }
        return norm;
    }
}
exports.rt = rt;