'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rtOne = void 0;
var debug_1 = require('@mangos/debug');
var rchisq_1 = require('../chi-2/rchisq.cjs');
var logger_1 = require('../../../packages/common/logger.cjs');
var global_rng_1 = require('../../rng/global-rng.cjs');
var r_func_1 = require('../../r-func.cjs');
const printer = (0, debug_1.debug)('rt');
function rtOne(df) {
    const rng = (0, global_rng_1.globalNorm)();
    if (isNaN(df) || df <= 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    const num = rng.random();
    if (!isFinite(df)) {
        return num;
    }
    const chOne = (0, rchisq_1.rchisqOne)(df);
    return num / (0, r_func_1.sqrt)(chOne / df);
}
exports.rtOne = rtOne;