'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.dunif = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
const printer = (0, debug_1.debug)('dunif');
function dunif(x, min = 0, max = 1, log = false) {
    if (isNaN(x) || isNaN(min) || isNaN(max)) {
        return x + min + max;
    }
    if (max <= min) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (min <= x && x <= max) {
        return log ? -(0, r_func_1.log)(max - min) : 1 / (max - min);
    }
    return (0, r_func_1.R_D__0)(log);
}
exports.dunif = dunif;