'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.punif = void 0;
var debug_1 = require('@mangos/debug');
const printer = (0, debug_1.debug)('punif');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
function punif(q, min = 0, max = 1, lowerTail = true, logP = false) {
    if (isNaN(q) || isNaN(min) || isNaN(max)) {
        return q + min + max;
    }
    if (max < min) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (!isFinite(min) || !isFinite(max)) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (q >= max) {
        return (0, r_func_1.R_DT_1)(lowerTail, logP);
    }
    if (q <= min) {
        return (0, r_func_1.R_DT_0)(lowerTail, logP);
    }
    const dnom = 1 / (max - min);
    if (lowerTail) {
        return (0, r_func_1.R_D_val)(logP, q * dnom - min * dnom);
    }
    return (0, r_func_1.R_D_val)(logP, max * dnom - q * dnom);
}
exports.punif = punif;