'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.qunif = void 0;
var logger_1 = require('../../../packages/common/logger.cjs');
var debug_1 = require('@mangos/debug');
var expm1_1 = require('../exp/expm1.cjs');
const printer = (0, debug_1.debug)('qunif');
function qunif(p, min = 0, max = 1, lowerTail = true, logP = false) {
    if (isNaN(p) || isNaN(min) || isNaN(max)) {
        return NaN;
    }
    const rc = (0, logger_1.R_Q_P01_check)(logP, p);
    if (rc !== undefined) {
        return rc;
    }
    if (!isFinite(min) || !isFinite(max)) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (max < min) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    if (max === min) {
        return min;
    }
    return min + (0, expm1_1.R_DT_qIv)(lowerTail, logP, p) * (max - min);
}
exports.qunif = qunif;