'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.rweibullOne = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var global_rng_1 = require('../../rng/global-rng.cjs');
const printer = (0, debug_1.debug)('rweibull');
function rweibullOne(shape, scale = 1) {
    const rng = (0, global_rng_1.globalUni)();
    if (!isFinite(shape) || !isFinite(scale) || shape <= 0 || scale <= 0) {
        if (scale === 0) {
            return 0;
        }
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    }
    return scale * (0, r_func_1.pow)(-(0, r_func_1.log)(rng.random()), 1 / shape);
}
exports.rweibullOne = rweibullOne;