'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.WilcoxonCache = void 0;
class WilcoxonCache {
    constructor() {
        this._map2 = {};
    }
    get(i, j, k) {
        const jstruct = this._map2[i];
        if (jstruct !== undefined) {
            const kstruct = jstruct[j];
            if (kstruct !== undefined) {
                return kstruct[k];
            }
        }
        return undefined;
    }
    set(i, j, k, value) {
        let jstruct = this._map2[i];
        if (jstruct === undefined) {
            jstruct = {};
            this._map2[i] = jstruct;
        }
        let kstruct = jstruct[j];
        if (kstruct === undefined) {
            kstruct = {};
            jstruct[j] = kstruct;
        }
        kstruct[k] = value;
    }
}
exports.WilcoxonCache = WilcoxonCache;