'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.dwilcox = void 0;
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var choose_1 = require('../../special/choose/index.cjs');
var cwilcox_1 = require('./cwilcox.cjs');
var WilcoxonCache_1 = require('./WilcoxonCache.cjs');
const printer_dwilcox = (0, debug_1.debug)('dwilcox');
function dwilcox(x, m, n, log = false) {
    m = (0, r_func_1.round)(m);
    n = (0, r_func_1.round)(n);
    const w = new WilcoxonCache_1.WilcoxonCache();
    if (isNaN(x) || isNaN(m) || isNaN(n)) {
        return x + m + n;
    }
    if (m <= 0 || n <= 0) {
        return (0, logger_1.ML_ERR_return_NAN2)(printer_dwilcox, logger_1.lineInfo4);
    }
    if (Math.abs(x - Math.round(x)) > 1e-7) {
        return (0, r_func_1.R_D__0)(log);
    }
    x = Math.round(x);
    if (x < 0 || x > m * n) {
        return (0, r_func_1.R_D__0)(log);
    }
    return log ? (0, r_func_1.log)((0, cwilcox_1.cwilcox)(x, m, n, w)) - (0, choose_1.lchoose)(m + n, n) : (0, cwilcox_1.cwilcox)(x, m, n, w) / (0, choose_1.choose)(m + n, n);
}
exports.dwilcox = dwilcox;