'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.M_SQRT2 = exports.isEmptyArray = exports.isArray = exports.nanFloat32Array = exports.emptyFloat64Array = exports.emptyFloat32Array = exports.repeatedCall64 = exports.repeatedCall = exports.Welch_Satterthwaite = exports.LogLevel = exports.sum = exports.atan = exports.tan = exports.sin = exports.cos = exports.sinh = exports.LN2 = exports.SQRT2 = exports.trunc = exports.PI = exports.sqrt = exports.sign = exports.round = exports.random = exports.pow = exports.min = exports.max = exports.log2 = exports.log1p = exports.log10 = exports.log = exports.imul = exports.fround = exports.floor = exports.expm1 = exports.exp = exports.ceil = exports.cbrt = exports.abs = exports.POSITIVE_INFINITY = exports.NEGATIVE_INFINITY = exports.MAX_SAFE_INTEGER = exports.EPSILON = exports.isFinite = exports.isNaN = exports.MAX_VALUE = exports.MIN_VALUE = exports.parseInt = exports.parseFloat = exports.isInteger = void 0;
exports.sumfp = exports.R_D_qIv = exports.R_D_log = exports.ldexp = exports.myfmod = exports.R_isnancpp = exports.R_pow = exports.R_pow_di = exports.R_D_fexp = exports.R_nonint = exports.R_D_negInonint = exports.isOdd = exports.imax2 = exports.fmod = exports.R_D_nonint_check = exports.R_D_exp = exports.R_P_bounds_01 = exports.R_D_half = exports.R_P_bounds_Inf_01 = exports.R_D_Cval = exports.R_D_Lval = exports.imin2 = exports.R_DT_val = exports.R_D_Clog = exports.R_D_val = exports.R_DT_1 = exports.R_DT_0 = exports.R_D__0 = exports.R_D__1 = exports.DBL_MIN_EXP = exports.DBL_MIN_VALUE_LN = exports.DBL_MAX_EXP = exports.M_LOG10_2 = exports.M_SQRT_2dPI = exports.M_LN_SQRT_PId2 = exports.M_LN_SQRT_2PI = exports.INT_MAX = exports.M_LN_SQRT_PI = exports.M_PI_2 = exports.M_1_PI = exports.M_LN_2PI = exports.M_2PI = exports.M_1_SQRT_2PI = exports.M_LN2 = exports.DBL_MAX = exports.DBL_MIN = exports.DBL_MANT_DIG = exports.DBL_EPSILON = exports.M_SQRT_32 = exports.frac = void 0;
exports.sumfp64 = void 0;
const {isInteger, parseFloat, parseInt, MIN_VALUE, MAX_VALUE, isNaN, isFinite, EPSILON, MAX_SAFE_INTEGER, NEGATIVE_INFINITY, POSITIVE_INFINITY} = Number;
exports.isInteger = isInteger;
exports.parseFloat = parseFloat;
exports.parseInt = parseInt;
exports.MIN_VALUE = MIN_VALUE;
exports.MAX_VALUE = MAX_VALUE;
exports.isNaN = isNaN;
exports.isFinite = isFinite;
exports.EPSILON = EPSILON;
exports.MAX_SAFE_INTEGER = MAX_SAFE_INTEGER;
exports.NEGATIVE_INFINITY = NEGATIVE_INFINITY;
exports.POSITIVE_INFINITY = POSITIVE_INFINITY;
const {abs, cbrt, ceil, exp, expm1, floor, fround, imul, log, log10, log1p, log2, max, min, pow, random, round, sign, sqrt, PI, trunc, SQRT2, LN2, sinh, cos, sin, tan, atan} = Math;
exports.abs = abs;
exports.cbrt = cbrt;
exports.ceil = ceil;
exports.exp = exp;
exports.expm1 = expm1;
exports.floor = floor;
exports.fround = fround;
exports.imul = imul;
exports.log = log;
exports.log10 = log10;
exports.log1p = log1p;
exports.log2 = log2;
exports.max = max;
exports.min = min;
exports.pow = pow;
exports.random = random;
exports.round = round;
exports.sign = sign;
exports.sqrt = sqrt;
exports.PI = PI;
exports.trunc = trunc;
exports.SQRT2 = SQRT2;
exports.LN2 = LN2;
exports.sinh = sinh;
exports.cos = cos;
exports.sin = sin;
exports.tan = tan;
exports.atan = atan;
function sum(x) {
    const rc = x.reduce((pv, v) => pv + v, 0);
    return rc;
}
exports.sum = sum;
var LogLevel;
(function (LogLevel) {
    LogLevel[LogLevel['ERROR'] = 0] = 'ERROR';
    LogLevel[LogLevel['WARN'] = 1] = 'WARN';
    LogLevel[LogLevel['INFO'] = 2] = 'INFO';
    LogLevel[LogLevel['DEBUG'] = 3] = 'DEBUG';
}(LogLevel = exports.LogLevel || (exports.LogLevel = {})));
function Welch_Satterthwaite(s, n) {
    const elts = s.map((_s, i) => _s * _s / n[i]);
    const dom = elts.map((e, i) => e * e / (n[i] - 1));
    return pow(sum(elts), 2) / sum(dom);
}
exports.Welch_Satterthwaite = Welch_Satterthwaite;
function repeatedCall(n, fn, ...arg) {
    let result;
    if (n === 0) {
        result = exports.emptyFloat32Array;
    } else if (n > 0 && isFinite(n)) {
        result = new Float32Array(n);
    } else {
        throw new TypeError(`"n" argument is not a finite number or negative`);
    }
    for (let i = 0; i < result.length; i++) {
        result[i] = fn(...arg);
    }
    return result;
}
exports.repeatedCall = repeatedCall;
function repeatedCall64(n, fn, ...args) {
    let result;
    if (n === 0) {
        result = exports.emptyFloat64Array;
    } else if (n > 0 && isFinite(n)) {
        result = new Float64Array(n);
    } else {
        throw new TypeError(`"n=${ n }" is not a positive finite number`);
    }
    for (let i = 0; i < result.length; i++) {
        result[i] = fn(...args);
    }
    return result;
}
exports.repeatedCall64 = repeatedCall64;
exports.emptyFloat32Array = new Float32Array(0);
exports.emptyFloat64Array = new Float64Array(0);
exports.nanFloat32Array = new Float32Array([NaN]);
function isArray(x) {
    return Array.isArray(x) || x instanceof Float32Array || x instanceof Float64Array;
}
exports.isArray = isArray;
function isEmptyArray(x) {
    return isArray(x) && x.length === 0;
}
exports.isEmptyArray = isEmptyArray;
exports.M_SQRT2 = 1.4142135623730951;
function frac(x) {
    return x - trunc(x);
}
exports.frac = frac;
exports.M_SQRT_32 = 5.656854249492381;
exports.DBL_EPSILON = 2.220446049250313e-16;
exports.DBL_MANT_DIG = 18;
exports.DBL_MIN = 2.2250738585072014e-308;
exports.DBL_MAX = 1.7976931348623157e+308;
exports.M_LN2 = 0.6931471805599453;
exports.M_1_SQRT_2PI = 0.3989422804014327;
exports.M_2PI = 6.283185307179586;
exports.M_LN_2PI = 1.8378770664093456;
exports.M_1_PI = 0.3183098861837907;
exports.M_PI_2 = PI / 2;
exports.M_LN_SQRT_PI = 0.5723649429247001;
exports.INT_MAX = 2 ** 31 - 1;
exports.M_LN_SQRT_2PI = 0.9189385332046728;
exports.M_LN_SQRT_PId2 = 0.22579135264472744;
exports.M_SQRT_2dPI = 0.7978845608028654;
exports.M_LOG10_2 = 0.3010299956639812;
exports.DBL_MAX_EXP = log2(MAX_VALUE);
exports.DBL_MIN_VALUE_LN = log(MIN_VALUE);
exports.DBL_MIN_EXP = log2(MIN_VALUE);
function R_D__1(logP) {
    return logP ? 0 : 1;
}
exports.R_D__1 = R_D__1;
const R_D__0 = logP => {
    return logP ? -Infinity : 0;
};
exports.R_D__0 = R_D__0;
const R_DT_0 = (lower_tail, log_p) => {
    return lower_tail ? (0, exports.R_D__0)(log_p) : R_D__1(log_p);
};
exports.R_DT_0 = R_DT_0;
const R_DT_1 = (lower_tail, log_p) => {
    return lower_tail ? R_D__1(log_p) : (0, exports.R_D__0)(log_p);
};
exports.R_DT_1 = R_DT_1;
function R_D_val(log_p, x) {
    return log_p ? log(x) : x;
}
exports.R_D_val = R_D_val;
function R_D_Clog(log_p, p) {
    return log_p ? log1p(-p) : 0.5 - p + 0.5;
}
exports.R_D_Clog = R_D_Clog;
function R_DT_val(lower_tail, log_p, x) {
    return lower_tail ? R_D_val(log_p, x) : R_D_Clog(log_p, x);
}
exports.R_DT_val = R_DT_val;
function imin2(x, y) {
    return min(trunc(x), trunc(y));
}
exports.imin2 = imin2;
function R_D_Lval(lowerTail, p) {
    return lowerTail ? p : 1 - p;
}
exports.R_D_Lval = R_D_Lval;
function R_D_Cval(lowerTail, p) {
    return lowerTail ? 1 - p : p;
}
exports.R_D_Cval = R_D_Cval;
function R_P_bounds_Inf_01(lowerTail, log_p, x) {
    if (!isFinite(x)) {
        if (x > 0) {
            return (0, exports.R_DT_1)(lowerTail, log_p);
        }
        return (0, exports.R_DT_0)(lowerTail, log_p);
    }
    return undefined;
}
exports.R_P_bounds_Inf_01 = R_P_bounds_Inf_01;
function R_D_half(log_p) {
    return log_p ? -exports.M_LN2 : 0.5;
}
exports.R_D_half = R_D_half;
function R_P_bounds_01(lower_tail, log_p, x, x_min, x_max) {
    if (x <= x_min)
        return (0, exports.R_DT_0)(lower_tail, log_p);
    if (x >= x_max)
        return (0, exports.R_DT_1)(lower_tail, log_p);
    return undefined;
}
exports.R_P_bounds_01 = R_P_bounds_01;
const R_D_exp = (log_p, x) => {
    return log_p ? x : exp(x);
};
exports.R_D_exp = R_D_exp;
function R_D_nonint_check(log, x, printer) {
    if (R_nonint(x)) {
        printer('non-integer x = %d', x);
        return (0, exports.R_D__0)(log);
    }
    return undefined;
}
exports.R_D_nonint_check = R_D_nonint_check;
function fmod(x, y) {
    return x % y;
}
exports.fmod = fmod;
function imax2(x, y) {
    return max(trunc(x), trunc(y));
}
exports.imax2 = imax2;
function isOdd(k) {
    return floor(k / 2) * 2 !== k;
}
exports.isOdd = isOdd;
function R_D_negInonint(x) {
    return x < 0 || R_nonint(x);
}
exports.R_D_negInonint = R_D_negInonint;
function R_nonint(x) {
    return !isInteger(x);
}
exports.R_nonint = R_nonint;
function R_D_fexp(give_log, f, x) {
    return give_log ? -0.5 * log(f) + x : exp(x) / sqrt(f);
}
exports.R_D_fexp = R_D_fexp;
function R_pow_di(x, n) {
    let pow = 1;
    if (isNaN(x))
        return x;
    if (n !== 0) {
        if (!isFinite(x))
            return R_pow(x, n);
        if (n < 0) {
            n = -n;
            x = 1 / x;
        }
        for (;;) {
            if (n & 1)
                pow *= x;
            if (n >>= 1)
                x *= x;
            else
                break;
        }
    }
    return pow;
}
exports.R_pow_di = R_pow_di;
function R_pow(x, y) {
    if (y === 2)
        return x * x;
    if (x === 1 || y === 0)
        return 1;
    if (x === 0) {
        if (y > 0)
            return 0;
        else if (y < 0)
            return Infinity;
        else
            return y;
    }
    if (isFinite(x) && isFinite(y)) {
        return pow(x, y);
    }
    if (isNaN(x) || isNaN(y))
        return x + y;
    if (!isFinite(x)) {
        if (x > 0)
            return y < 0 ? 0 : Infinity;
        else {
            if (isFinite(y) && y === floor(y))
                return y < 0 ? 0 : myfmod(y, 2) ? x : -x;
        }
    }
    if (!isFinite(y)) {
        if (x >= 0) {
            if (y > 0)
                return x >= 1 ? Infinity : 0;
            else
                return x < 1 ? Infinity : 0;
        }
    }
    return NaN;
}
exports.R_pow = R_pow;
function R_isnancpp(x) {
    return isNaN(x);
}
exports.R_isnancpp = R_isnancpp;
function myfmod(x1, x2) {
    const q = x1 / x2;
    return x1 - floor(q) * x2;
}
exports.myfmod = myfmod;
function ldexp(x, y) {
    if (isNaN(x) || isNaN(y)) {
        return x + y;
    }
    if (!isFinite(x) || !isFinite(y)) {
        return Infinity;
    }
    return x * pow(2, y);
}
exports.ldexp = ldexp;
function R_D_log(log_p, p) {
    return log_p ? p : log(p);
}
exports.R_D_log = R_D_log;
function R_D_qIv(logP, p) {
    return logP ? exp(p) : p;
}
exports.R_D_qIv = R_D_qIv;
function sumfp(x) {
    return x.reduce((pv, v) => pv + v, 0);
}
exports.sumfp = sumfp;
function sumfp64(x) {
    return x.reduce((pv, v) => pv + v, 0);
}
exports.sumfp64 = sumfp64;