'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.Inversion = void 0;
var irng_1 = require('../../irng.cjs');
var qnorm_1 = require('../../../distributions/normal/qnorm.cjs');
var normal_rng_1 = require('../normal-rng.cjs');
const BIG = 134217728;
class Inversion extends normal_rng_1.IRNGNormal {
    constructor(_rng) {
        super(_rng, 'Inversion');
        this._rng.unregister(irng_1.MessageType.INIT, this.reset.bind(this));
    }
    random() {
        let u1 = this._rng.random();
        const t = this._rng.random();
        u1 = new Int32Array([BIG * u1])[0] + t;
        const result = (0, qnorm_1.qnorm)(u1 / BIG, 0, 1, !!1, !!0);
        return result;
    }
}
exports.Inversion = Inversion;
Inversion.kind = 'INVERSION';