'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.SuperDuper = void 0;
var fixup_1 = require('../fixup.cjs');
var irng_1 = require('../irng.cjs');
var seed_1 = require('../seed.cjs');
var seedcheck_1 = require('../seedcheck.cjs');
var r_func_1 = require('../../r-func.cjs');
const SEED_LEN = 2;
class SuperDuper extends irng_1.IRNG {
    constructor(_seed = (0, seed_1.default)()) {
        super('Super-Duper');
        this.m_seed = new Int32Array(SEED_LEN);
        this.init(_seed);
    }
    random() {
        const s = this.m_seed;
        s[0] ^= s[0] >>> 15 & 131071;
        s[0] ^= s[0] << 17;
        s[1] *= 69069;
        const un = new Uint32Array(SEED_LEN);
        un[0] = s[0];
        un[1] = s[1];
        un[0] = un[0] ^ un[1];
        return (0, fixup_1.fixup)(un[0] * fixup_1.i2_32m1);
    }
    fixupSeeds() {
        const s = this.m_seed;
        if (s[0] === 0)
            s[0] = 1;
        s[1] |= 1;
        return;
    }
    init(_seed = (0, seed_1.default)()) {
        const s = new Uint32Array([_seed]);
        for (let j = 0; j < 50; j++) {
            s[0] = 69069 * s[0] + 1;
        }
        for (let j = 0; j < this.m_seed.length; j++) {
            s[0] = 69069 * s[0] + 1;
            this.m_seed[j] = s[0];
        }
        this.fixupSeeds();
        super.init(_seed);
    }
    set seed(_seed) {
        (0, seedcheck_1.seedCheck)(this.name, _seed, SEED_LEN);
        this.m_seed.set(_seed);
        this.fixupSeeds();
    }
    get seed() {
        return this.m_seed.slice();
    }
    get cut() {
        return r_func_1.INT_MAX;
    }
}
exports.SuperDuper = SuperDuper;
SuperDuper.kind = 'SUPER_DUPER';