'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.R_unif_index = void 0;
var r_func_1 = require('../r-func.cjs');
const U = 2 ** 25;
function ru(unif_rand) {
    return ((0, r_func_1.floor)(U * unif_rand.random()) + unif_rand.random()) / U;
}
function rbits(bits, unif_rand) {
    let v = 0;
    for (let n = 0; n <= bits; n += 16) {
        const ran = unif_rand.random();
        const v1 = new Int32Array([(0, r_func_1.trunc)(ran * 65536)]);
        v = 65536 * v + BigInt(v1[0]);
    }
    return v & (1 << BigInt(bits)) - 1;
}
function R_unif_index_0(dn, unif_rand) {
    const cut = unif_rand.cut;
    const u = dn > cut ? ru(unif_rand) : unif_rand.random();
    return (0, r_func_1.trunc)(dn * u);
}
function R_unif_index(dn, unif_rand, sampleKind) {
    if (sampleKind === 'ROUNDING') {
        return R_unif_index_0(dn, unif_rand);
    }
    const bits = (0, r_func_1.trunc)((0, r_func_1.ceil)((0, r_func_1.log2)(dn)));
    let dv = dn;
    while (dv >= dn) {
        dv = Number(rbits(bits, unif_rand));
    }
    return dv;
}
exports.R_unif_index = R_unif_index;