'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.Rf_gamma_cody = void 0;
var sinpi_1 = require('../../trigonometry/sinpi.cjs');
var r_func_1 = require('../../r-func.cjs');
function Rf_gamma_cody(x) {
    const sqrtpi = 0.9189385332046728;
    const xbig = 171.624;
    const p = [
        -1.716185138865495,
        24.76565080557592,
        -379.80425647094563,
        629.3311553128184,
        866.9662027904133,
        -31451.272968848367,
        -36144.413418691176,
        66456.14382024054
    ];
    const q = [
        -30.840230011973897,
        315.35062697960416,
        -1015.1563674902192,
        -3107.771671572311,
        22538.11842098015,
        4755.846277527881,
        -134659.9598649693,
        -115132.25967555349
    ];
    const c = [
        -0.001910444077728,
        0.00084171387781295,
        -0.0005952379913043012,
        0.0007936507935003503,
        -0.0027777777777776816,
        0.08333333333333333,
        0.0057083835261
    ];
    let i;
    let n;
    let parity;
    let fact;
    let xden;
    let xnum;
    let y;
    let z;
    let yi;
    let res;
    let sum;
    let ysq;
    parity = 0;
    fact = 1;
    n = 0;
    y = x;
    if (y <= 0) {
        y = -x;
        yi = (0, r_func_1.trunc)(y);
        res = y - yi;
        if (res !== 0) {
            if (yi !== (0, r_func_1.trunc)(yi * 0.5) * 2) {
                parity = 1;
            }
            fact = -r_func_1.PI / (0, sinpi_1.sinpi)(res);
            y += 1;
        } else {
            return Infinity;
        }
    }
    if (y < r_func_1.DBL_EPSILON) {
        if (y >= r_func_1.DBL_MIN) {
            res = 1 / y;
        } else {
            return Infinity;
        }
    } else if (y < 12) {
        yi = y;
        if (y < 1) {
            z = y;
            y += 1;
        } else {
            n = (0, r_func_1.trunc)(y) - 1;
            y -= n;
            z = y - 1;
        }
        xnum = 0;
        xden = 1;
        for (i = 0; i < 8; ++i) {
            xnum = (xnum + p[i]) * z;
            xden = xden * z + q[i];
        }
        res = xnum / xden + 1;
        if (yi < y) {
            res /= yi;
        } else if (yi > y) {
            for (i = 0; i < n; ++i) {
                res *= y;
                y += 1;
            }
        }
    } else {
        if (y <= xbig) {
            ysq = y * y;
            sum = c[6];
            for (i = 0; i < 6; ++i) {
                sum = sum / ysq + c[i];
            }
            sum = sum / y - y + sqrtpi;
            sum += (y - 0.5) * (0, r_func_1.log)(y);
            res = (0, r_func_1.exp)(sum);
        } else {
            return Infinity;
        }
    }
    if (parity)
        res = -res;
    if (fact !== 1)
        res = fact / res;
    return res;
}
exports.Rf_gamma_cody = Rf_gamma_cody;