'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var gamma_1 = require('../gamma/index.cjs');
var lbeta_1 = require('./lbeta.cjs');
var r_func_1 = require('../../r-func.cjs');
const xmax = 171.61447887182297;
const lnsml = -708.3964185322641;
const printer_beta = (0, debug_1.debug)('beta');
function beta(a, b) {
    if (isNaN(a) || isNaN(b))
        return a + b;
    if (a < 0 || b < 0)
        return (0, logger_1.ML_ERR_return_NAN2)(printer_beta, logger_1.lineInfo4);
    else if (a === 0 || b === 0)
        return Infinity;
    else if (!isFinite(a) || !isFinite(b))
        return 0;
    if (a + b < xmax) {
        return 1 / (0, gamma_1.gamma)(a + b) * (0, gamma_1.gamma)(a) * (0, gamma_1.gamma)(b);
    } else {
        const val = (0, lbeta_1.default)(a, b);
        if (val < lnsml) {
            (0, logger_1.ML_ERROR2)(logger_1.ME.ME_UNDERFLOW, 'beta', printer_beta);
        }
        return (0, r_func_1.exp)(val);
    }
}
exports.default = beta;