'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
var debug_1 = require('@mangos/debug');
var logger_1 = require('../../../packages/common/logger.cjs');
var r_func_1 = require('../../r-func.cjs');
var gamma_1 = require('../gamma/index.cjs');
var lgammafn_sign_1 = require('../gamma/lgammafn_sign.cjs');
var lgammacor_1 = require('../gamma/lgammacor.cjs');
const printer = (0, debug_1.debug)('lbeta');
function lbeta(a, b) {
    let corr;
    let p;
    let q;
    if (isNaN(a) || isNaN(b))
        return a + b;
    p = q = a;
    if (b < p)
        p = b;
    if (b > q)
        q = b;
    if (p < 0)
        return (0, logger_1.ML_ERR_return_NAN2)(printer, logger_1.lineInfo4);
    else if (p === 0) {
        return Infinity;
    } else if (!isFinite(q)) {
        return -Infinity;
    }
    if (p >= 10) {
        corr = (0, lgammacor_1.lgammacor)(p) + (0, lgammacor_1.lgammacor)(q) - (0, lgammacor_1.lgammacor)(p + q);
        return Math.log(q) * -0.5 + r_func_1.M_LN_SQRT_2PI + corr + (p - 0.5) * Math.log(p / (p + q)) + q * Math.log1p(-p / (p + q));
    } else if (q >= 10) {
        corr = (0, lgammacor_1.lgammacor)(q) - (0, lgammacor_1.lgammacor)(p + q);
        return (0, lgammafn_sign_1.lgammafn_sign)(p) + corr + p - p * Math.log(p + q) + (q - 0.5) * Math.log1p(-p / (p + q));
    } else {
        if (p < 1e-306)
            return (0, lgammafn_sign_1.lgammafn_sign)(p) + ((0, lgammafn_sign_1.lgammafn_sign)(q) - (0, lgammafn_sign_1.lgammafn_sign)(p + q));
        else
            return Math.log((0, gamma_1.gamma)(p) * ((0, gamma_1.gamma)(q) / (0, gamma_1.gamma)(p + q)));
    }
}
exports.default = lbeta;