'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.cospi = void 0;
var debug_1 = require('@mangos/debug');
var r_func_1 = require('../r-func.cjs');
var logger_1 = require('../../packages/common/logger.cjs');
const printer_cospi = (0, debug_1.debug)('cospi');
function cospi(x) {
    if (isNaN(x))
        return x;
    if (!isFinite(x)) {
        (0, logger_1.ML_ERROR2)(logger_1.ME.ME_DOMAIN, logger_1.lineInfo4, printer_cospi);
        return NaN;
    }
    x = (0, r_func_1.fmod)(Math.abs(x), 2);
    if ((0, r_func_1.fmod)(x, 1) === 0.5)
        return 0;
    if (x === 1)
        return -1;
    if (x === 0)
        return 1;
    return Math.cos(Math.PI * x);
}
exports.cospi = cospi;