'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.sinpi = void 0;
var debug_1 = require('@mangos/debug');
var r_func_1 = require('../r-func.cjs');
var logger_1 = require('../../packages/common/logger.cjs');
const printer_sinpi = (0, debug_1.debug)('sinpi');
function sinpi(x) {
    if (isNaN(x))
        return x;
    if (!isFinite(x)) {
        (0, logger_1.ML_ERROR2)(logger_1.ME.ME_DOMAIN, 'sinpi not finite', printer_sinpi);
        return NaN;
    }
    x = (0, r_func_1.fmod)(x, 2);
    if (x <= -1)
        x += 2;
    else if (x > 1)
        x -= 2;
    if (x === 0 || x === 1)
        return 0;
    if (x === 0.5)
        return 1;
    if (x === -0.5)
        return -1;
    return Math.sin(Math.PI * x);
}
exports.sinpi = sinpi;