'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
exports.atanpi = exports.tanpi = void 0;
var debug_1 = require('@mangos/debug');
var r_func_1 = require('../r-func.cjs');
var logger_1 = require('../../packages/common/logger.cjs');
const printer_tanpi = (0, debug_1.debug)('tanpi');
function tanpi(x) {
    if (isNaN(x))
        return x;
    if (!isFinite(x)) {
        (0, logger_1.ML_ERROR2)(logger_1.ME.ME_DOMAIN, logger_1.lineInfo4, printer_tanpi);
        return NaN;
    }
    x = (0, r_func_1.fmod)(x, 1);
    if (x <= -0.5) {
        x++;
    } else if (x > 0.5) {
        x--;
    }
    return x === 0 ? 0 : x === 0.5 ? NaN : (0, r_func_1.tan)(Math.PI * x);
}
exports.tanpi = tanpi;
function atanpi(x) {
    return (0, r_func_1.atan)(x) / Math.PI;
}
exports.atanpi = atanpi;