import {
    abs as fabs,
    max as fmax2,
    min as fmin2
} from '../../r-func.mjs';
import {
    POSITIVE_INFINITY,
    EPSILON,
    isNaN,
    isFinite
} from '../../r-func.mjs';
export default function hypot(a, b) {
    let p;
    let r;
    let s;
    let t;
    let tmp;
    let u;
    if (isNaN(a) || isNaN(b)) {
        return a + b;
    }
    if (!isFinite(a) || !isFinite(b)) {
        return POSITIVE_INFINITY;
    }
    p = fmax2(fabs(a), fabs(b));
    if (p !== 0) {
        tmp = fmin2(fabs(a), fabs(b)) / p;
        r = tmp * tmp;
        for (;;) {
            t = 4 + r;
            if (fabs(r) < 2 * EPSILON)
                break;
            s = r / t;
            u = 1 + 2 * s;
            p *= u;
            tmp = s / u;
            r *= tmp * tmp;
        }
    }
    return p;
}