import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../packages/common/logger.mjs';
const printer = debug('chebyshev_eval');
export function chebyshev_eval(x, a, n) {
    let b0;
    let b1;
    let b2;
    let i;
    if (n < 1 || n > 1000) {
        return ML_ERR_return_NAN2(printer, lineInfo4);
    }
    if (x < -1.1 || x > 1.1) {
        return ML_ERR_return_NAN2(printer, lineInfo4);
    }
    const twox = x * 2;
    b2 = b1 = 0;
    b0 = 0;
    for (i = 1; i <= n; i++) {
        b2 = b1;
        b1 = b0;
        b0 = twox * b1 - b2 + a[n - i];
    }
    return (b0 - b2) * 0.5;
}