import { dbeta_scalar } from './dbeta.mjs';
import { dnbeta_scalar } from './dnbeta.mjs';
import { pbeta as _pbeta } from './pbeta.mjs';
import { pnbeta as _pnbeta } from './pnbeta.mjs';
import { qbeta as _qbeta } from './qbeta.mjs';
import { qnbeta as _qnbeta } from './qnbeta.mjs';
import { rchisqOne } from '../chi-2/rchisq.mjs';
import { rnchisqOne } from '../chi-2/rnchisq.mjs';
import { rbetaOne } from './rbeta.mjs';
import { repeatedCall } from '../../r-func.mjs';
export {
    rbetaOne
};
export function dbeta(x, shape1, shape2, ncp, log = false) {
    if (ncp === undefined) {
        return dbeta_scalar(x, shape1, shape2, log);
    } else {
        return dnbeta_scalar(x, shape1, shape2, ncp, log);
    }
}
export function pbeta(q, shape1, shape2, ncp, lowerTail = true, logP = false) {
    if (ncp === undefined) {
        return _pbeta(q, shape1, shape2, lowerTail, logP);
    } else {
        return _pnbeta(q, shape1, shape2, ncp, lowerTail, logP);
    }
}
export function qbeta(p, shape1, shape2, ncp, lowerTail = true, logP = false) {
    if (ncp === undefined) {
        return _qbeta(p, shape1, shape2, lowerTail, logP);
    } else {
        return _qnbeta(p, shape1, shape2, ncp, lowerTail, logP);
    }
}
export function rbeta(n, shape1, shape2, ncp) {
    if (ncp === undefined) {
        return repeatedCall(n, rbetaOne, shape1, shape2);
    } else {
        const ar = repeatedCall(n, rnchisqOne, 2 * shape1, ncp);
        const br = repeatedCall(n, rchisqOne, 2 * shape2);
        const result = ar.map((a, i) => a / (a + br[i]));
        return result;
    }
}