import { dchisq as _dchisq } from './dchisq.mjs';
import { dnchisq as _dnchisq } from './dnchisq.mjs';
import { pchisq as _pchisq } from './pchisq.mjs';
import { pnchisq as _pnchisq } from './pnchisq.mjs';
import { qchisq as _qchisq } from './qchisq.mjs';
import { qnchisq as _qnchisq } from './qnchisq.mjs';
import { rchisqOne as _rchisqOne } from './rchisq.mjs';
import { rnchisqOne as _rnchisqOne } from './rnchisq.mjs';
import { repeatedCall64 } from '../../r-func.mjs';
export function rchisq(n, df, ncp) {
    return ncp === undefined ? repeatedCall64(n, _rchisqOne, df) : repeatedCall64(n, _rnchisqOne, df, ncp);
}
export function rchisqOne(df, ncp) {
    return ncp === undefined ? _rchisqOne(df) : _rnchisqOne(df, ncp);
}
export function qchisq(p, df, ncp, lowerTail = true, logP = false) {
    return ncp === undefined ? _qchisq(p, df, lowerTail, logP) : _qnchisq(p, df, ncp, lowerTail, logP);
}
export function pchisq(p, df, ncp, lowerTail = true, logP = false) {
    return ncp === undefined ? _pchisq(p, df, lowerTail, logP) : _pnchisq(p, df, ncp, lowerTail, logP);
}
export function dchisq(x, df, ncp, log = false) {
    return ncp === undefined ? _dchisq(x, df, log) : _dnchisq(x, df, ncp, log);
}