import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import { rgamma } from '../gamma/rgamma.mjs';
import { rpoisOne } from '../poisson/rpois.mjs';
import { rchisqOne } from './rchisq.mjs';
const printer = debug('rnchisq');
export function rnchisqOne(df, lambda) {
    if (!isFinite(df) || !isFinite(lambda) || df < 0 || lambda < 0) {
        return ML_ERR_return_NAN2(printer, lineInfo4);
    }
    if (lambda === 0) {
        return df === 0 ? 0 : rgamma(df / 2, 2);
    } else {
        let r = rpoisOne(lambda / 2);
        if (r > 0)
            r = rchisqOne(2 * r);
        if (df > 0)
            r += rgamma(df / 2, 2);
        return r;
    }
}