import {
    M_LN2,
    R_D_Cval,
    R_D_log,
    R_D_Lval
} from '../../r-func.mjs';
const {exp, expm1, log, log1p} = Math;
function R_DT_qIv(lower_tail, log_p, p) {
    if (log_p) {
        return lower_tail ? exp(p) : -expm1(p);
    }
    return R_D_Lval(lower_tail, p);
}
function R_DT_CIv(lower_tail, log_p, p) {
    return log_p ? lower_tail ? -expm1(p) : exp(p) : R_D_Cval(lower_tail, p);
}
function R_D_LExp(log_p, x) {
    return log_p ? R_Log1_Exp(x) : log1p(-x);
}
function R_Log1_Exp(x) {
    if (x > -M_LN2) {
        return log(-expm1(x));
    }
    return log1p(-exp(x));
}
function R_DT_Clog(lower_tail, log_p, p) {
    return lower_tail ? R_D_LExp(log_p, p) : R_D_log(log_p, p);
}
function R_DT_log(lower_tail, log_p, p) {
    return lower_tail ? R_D_log(log_p, p) : R_D_LExp(log_p, p);
}
export {
    R_DT_qIv,
    R_DT_CIv,
    R_DT_log,
    R_DT_Clog,
    R_Log1_Exp,
    R_D_LExp
};