import { dexp as _dexp } from './dexp.mjs';
import { pexp as _pexp } from './pexp.mjs';
import { qexp as _qexp } from './qexp.mjs';
import { rexpOne } from './rexp.mjs';
import { repeatedCall64 } from '../../r-func.mjs';
export function dexp(x, rate = 1, log = false) {
    return _dexp(x, 1 / rate, log);
}
export function pexp(q, rate = 1, lowerTail = true, logP = false) {
    return _pexp(q, 1 / rate, lowerTail, logP);
}
export function qexp(p, rate = 1, lowerTail = true, logP = false) {
    return _qexp(p, 1 / rate, lowerTail, logP);
}
export function rexp(n, rate = 1) {
    return repeatedCall64(n, rexpOne, rate);
}
export {
    rexpOne
};