import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import {
    R_D_exp,
    R_DT_0
} from '../../r-func.mjs';
import { debug } from '@mangos/debug';
import { R_Log1_Exp } from './expm1.mjs';
const printer = debug('pexp');
export function pexp(q, scale, lower_tail, log_p) {
    if (isNaN(q) || isNaN(scale))
        return q + scale;
    if (scale < 0) {
        return ML_ERR_return_NAN2(printer, lineInfo4);
    }
    if (q <= 0)
        return R_DT_0(lower_tail, log_p);
    q = -(q / scale);
    return lower_tail ? log_p ? R_Log1_Exp(q) : -Math.expm1(q) : R_D_exp(log_p, q);
}