import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4,
    R_Q_P01_check
} from '../../../packages/common/logger.mjs';
import { R_DT_0 } from '../../r-func.mjs';
import { R_DT_Clog } from './expm1.mjs';
const printer = debug('qexp');
export function qexp(p, scale, lower_tail, log_p) {
    if (isNaN(p) || isNaN(scale))
        return p + scale;
    if (scale < 0)
        return ML_ERR_return_NAN2(printer, lineInfo4);
    const rc = R_Q_P01_check(log_p, p);
    if (rc !== undefined) {
        return rc;
    }
    if (p === R_DT_0(lower_tail, log_p))
        return 0;
    return -scale * R_DT_Clog(lower_tail, log_p, p);
}