import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import { exp_rand } from '../exp/sexp.mjs';
import { rpoisOne } from '../poisson/rpois.mjs';
import { globalUni } from '../../rng/global-rng.mjs';
const printer = debug('rgeom');
export function rgeomOne(p) {
    const rng = globalUni();
    if (!isFinite(p) || p <= 0 || p > 1)
        return ML_ERR_return_NAN2(printer, lineInfo4);
    return rpoisOne(exp_rand(rng) * ((1 - p) / p));
}