import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import {
    log as _log,
    abs,
    exp
} from '../../r-func.mjs';
const printer_dlogis = debug('dlogis');
export function dlogis(x, location = 0, scale = 1, log = false) {
    if (isNaN(x) || isNaN(location) || isNaN(scale))
        return NaN;
    if (scale <= 0) {
        return ML_ERR_return_NAN2(printer_dlogis, lineInfo4);
    }
    x = abs((x - location) / scale);
    const e = exp(-x);
    const f = 1 + e;
    return log ? -(x + _log(scale * f * f)) : e / (scale * f * f);
}