import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import { globalUni } from '../../rng/index.mjs';
const printer_rlogis = debug('rlogis');
export function rlogisOne(location = 0, scale = 1) {
    const rng = globalUni();
    if (isNaN(location) || !isFinite(scale)) {
        return ML_ERR_return_NAN2(printer_rlogis, lineInfo4);
    }
    if (scale === 0 || !isFinite(location))
        return location;
    else {
        const u = rng.random();
        return location + scale * Math.log(u / (1 - u));
    }
}