import { R_Q_P01_boundaries } from '../../../packages/common/logger.mjs';
import { exp } from '../../r-func.mjs';
import { qnorm } from '../normal/qnorm.mjs';
export function qlnorm(p, meanlog = 0, sdlog = 1, lowerTail = true, logP = false) {
    if (isNaN(p) || isNaN(meanlog) || isNaN(sdlog))
        return p + meanlog + sdlog;
    const rc = R_Q_P01_boundaries(lowerTail, logP, p, 0, Infinity);
    if (rc !== undefined) {
        return rc;
    }
    return exp(qnorm(p, meanlog, sdlog, lowerTail, logP));
}