import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import { rnormOne } from '../normal/rnorm.mjs';
import { exp } from '../../r-func.mjs';
const printer = debug('rlnorm');
export function rlnormOne(meanlog = 0, sdlog = 1) {
    if (isNaN(meanlog) || !isFinite(sdlog) || sdlog < 0) {
        return ML_ERR_return_NAN2(printer, lineInfo4);
    }
    return exp(rnormOne(meanlog, sdlog));
}