'use strict';
import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import { globalNorm } from '../../rng/global-rng.mjs';
const printer = debug('rnorm');
export function rnormOne(mean = 0, sd = 1) {
    const rng = globalNorm();
    if (isNaN(mean) || !isFinite(sd) || sd < 0) {
        return ML_ERR_return_NAN2(printer, lineInfo4);
    }
    if (sd === 0 || !isFinite(mean)) {
        return mean;
    }
    return mean + sd * rng.random();
}