'use strict';
export {
    dsignrank
} from './dsign.mjs';
export {
    psignrank
} from './psign.mjs';
export {
    qsignrank
} from './qsign.mjs';
import {
    unRegisterBackend as unregister_dsign_backend,
    registerBackend as register_dsign_backend
} from './dsign.mjs';
import {
    unRegisterBackend as unregister_qsign_backend,
    registerBackend as register_qsign_backend
} from './qsign.mjs';
import {
    unRegisterBackend as unregister_psign_backend,
    registerBackend as register_psign_backend
} from './psign.mjs';
import { rsignrankOne } from './rsign.mjs';
import { repeatedCall64 } from '../../r-func.mjs';
import { initWasm as initSignRankBackend } from './csignrank_wasm.mjs';
export function rsignrank(nn, n) {
    return repeatedCall64(nn, rsignrankOne, n);
}
function useWasmBackendSignRank() {
    const fns = initSignRankBackend();
    register_dsign_backend(fns);
    register_qsign_backend(fns);
    register_psign_backend(fns);
}
function clearBackendSignRank() {
    let rc = 0;
    if (unregister_dsign_backend()) {
        rc++;
    }
    if (unregister_qsign_backend()) {
        rc++;
    }
    if (unregister_psign_backend()) {
        rc++;
    }
    return rc === 3 ? true : false;
}
export {
    useWasmBackendSignRank,
    clearBackendSignRank,
    rsignrankOne
};