'use strict';
import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import { globalUni } from '../../rng/global-rng.mjs';
import {
    floor,
    trunc,
    round,
    isNaN,
    INT_MAX
} from '../../r-func.mjs';
const printer = debug('rsignrank');
export function rsignrankOne(n) {
    const rng = globalUni();
    if (isNaN(n)) {
        return n;
    }
    if (n > INT_MAX)
        return 0;
    n = round(n);
    if (n < 0) {
        return ML_ERR_return_NAN2(printer, lineInfo4);
    }
    if (n === 0) {
        return 0;
    }
    let r = 0;
    const k = trunc(n);
    for (let i = 0; i < k;) {
        r += ++i * floor(rng.random() + 0.5);
    }
    return r;
}