'use strict';
import { debug } from '@mangos/debug';
import { rchisqOne } from '../chi-2/rchisq.mjs';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import { globalNorm } from '../../rng/global-rng.mjs';
import { sqrt } from '../../r-func.mjs';
const printer = debug('rt');
export function rtOne(df) {
    const rng = globalNorm();
    if (isNaN(df) || df <= 0) {
        return ML_ERR_return_NAN2(printer, lineInfo4);
    }
    const num = rng.random();
    if (!isFinite(df)) {
        return num;
    }
    const chOne = rchisqOne(df);
    return num / sqrt(chOne / df);
}