'use strict';
import {
    M_1_SQRT_2PI,
    pow,
    exp
} from '../../r-func.mjs';
import { pnorm5 as pnorm } from '../normal/pnorm.mjs';
const bb = 8;
const C2 = -50;
const wlar = 3;
const wincr1 = 2;
const wincr2 = 3;
const nleg = 12;
const ihalf = 6;
const xleg = [
    0.9815606342467192,
    0.9041172563704749,
    0.7699026741943047,
    0.5873179542866175,
    0.3678314989981802,
    0.1252334085114689
];
const aleg = [
    0.04717533638651183,
    0.10693932599531843,
    0.16007832854334622,
    0.20316742672306592,
    0.2334925365383548,
    0.24914704581340277
];
const C3 = 60;
const C1 = -30;
export function wprob(w, rr, cc) {
    let a;
    let ac;
    let pr_w;
    let b;
    let c;
    let pminus;
    let pplus;
    let qexpo;
    let rinsum;
    let wi;
    let wincr;
    let xx;
    let blb;
    let bub;
    let einsum;
    let elsum;
    let j;
    const qsqz = w * 0.5;
    if (qsqz >= bb) {
        return 1;
    }
    pr_w = 2 * pnorm(qsqz, 0, 1, true, false) - 1;
    if (pr_w >= exp(C2 / cc)) {
        pr_w = pow(pr_w, cc);
    } else {
        pr_w = 0;
    }
    if (w > wlar) {
        wincr = wincr1;
    } else {
        wincr = wincr2;
    }
    blb = qsqz;
    const binc = (bb - qsqz) / wincr;
    bub = blb + binc;
    einsum = 0;
    const cc1 = cc - 1;
    for (wi = 1; wi <= wincr; wi++) {
        elsum = 0;
        a = 0.5 * (bub + blb);
        b = 0.5 * (bub - blb);
        for (let jj = 1; jj <= nleg; jj++) {
            if (ihalf < jj) {
                j = nleg - jj + 1;
                xx = xleg[j - 1];
            } else {
                j = jj;
                xx = -xleg[j - 1];
            }
            c = b * xx;
            ac = a + c;
            qexpo = ac * ac;
            if (qexpo > C3) {
                break;
            }
            pplus = 2 * pnorm(ac, 0, 1, true, false);
            pminus = 2 * pnorm(ac, w, 1, true, false);
            rinsum = pplus * 0.5 - pminus * 0.5;
            if (rinsum >= exp(C1 / cc1)) {
                rinsum = aleg[j - 1] * exp(-(0.5 * qexpo)) * pow(rinsum, cc1);
                elsum += rinsum;
            }
        }
        elsum *= 2 * b * cc * M_1_SQRT_2PI;
        einsum += elsum;
        blb = bub;
        bub += binc;
    }
    pr_w += einsum;
    if (pr_w <= exp(C1 / rr)) {
        return 0;
    }
    pr_w = pow(pr_w, rr);
    if (pr_w >= 1) {
        return 1;
    }
    return pr_w;
}