'use strict';
import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import {
    pow,
    log
} from '../../r-func.mjs';
import { globalUni } from '../../rng/global-rng.mjs';
const printer = debug('rweibull');
export function rweibullOne(shape, scale = 1) {
    const rng = globalUni();
    if (!isFinite(shape) || !isFinite(scale) || shape <= 0 || scale <= 0) {
        if (scale === 0) {
            return 0;
        }
        return ML_ERR_return_NAN2(printer, lineInfo4);
    }
    return scale * pow(-log(rng.random()), 1 / shape);
}