'use strict';
import { debug } from '@mangos/debug';
import {
    ML_ERR_return_NAN2,
    lineInfo4
} from '../../../packages/common/logger.mjs';
import {
    R_D__0,
    log as _log,
    round
} from '../../r-func.mjs';
import {
    choose,
    lchoose
} from '../../special/choose/index.mjs';
import { cwilcox } from './cwilcox.mjs';
import { WilcoxonCache } from './WilcoxonCache.mjs';
const printer_dwilcox = debug('dwilcox');
export function dwilcox(x, m, n, log = false) {
    m = round(m);
    n = round(n);
    const w = new WilcoxonCache();
    if (isNaN(x) || isNaN(m) || isNaN(n)) {
        return x + m + n;
    }
    if (m <= 0 || n <= 0) {
        return ML_ERR_return_NAN2(printer_dwilcox, lineInfo4);
    }
    if (Math.abs(x - Math.round(x)) > 1e-7) {
        return R_D__0(log);
    }
    x = Math.round(x);
    if (x < 0 || x > m * n) {
        return R_D__0(log);
    }
    return log ? _log(cwilcox(x, m, n, w)) - lchoose(m + n, n) : cwilcox(x, m, n, w) / choose(m + n, n);
}