'use strict';
import { MessageType } from '../../irng.mjs';
import { qnorm } from '../../../distributions/normal/qnorm.mjs';
import { IRNGNormal } from '../normal-rng.mjs';
const BIG = 134217728;
export class Inversion extends IRNGNormal {
    constructor(_rng) {
        super(_rng, 'Inversion');
        this._rng.unregister(MessageType.INIT, this.reset.bind(this));
    }
    random() {
        let u1 = this._rng.random();
        const t = this._rng.random();
        u1 = new Int32Array([BIG * u1])[0] + t;
        const result = qnorm(u1 / BIG, 0, 1, !!1, !!0);
        return result;
    }
}
Inversion.kind = 'INVERSION';