import {
    floor,
    ceil,
    log2,
    trunc
} from '../r-func.mjs';
const U = 2 ** 25;
function ru(unif_rand) {
    return (floor(U * unif_rand.random()) + unif_rand.random()) / U;
}
function rbits(bits, unif_rand) {
    let v = 0;
    for (let n = 0; n <= bits; n += 16) {
        const ran = unif_rand.random();
        const v1 = new Int32Array([trunc(ran * 65536)]);
        v = 65536 * v + BigInt(v1[0]);
    }
    return v & (1 << BigInt(bits)) - 1;
}
function R_unif_index_0(dn, unif_rand) {
    const cut = unif_rand.cut;
    const u = dn > cut ? ru(unif_rand) : unif_rand.random();
    return trunc(dn * u);
}
export function R_unif_index(dn, unif_rand, sampleKind) {
    if (sampleKind === 'ROUNDING') {
        return R_unif_index_0(dn, unif_rand);
    }
    const bits = trunc(ceil(log2(dn)));
    let dv = dn;
    while (dv >= dn) {
        dv = Number(rbits(bits, unif_rand));
    }
    return dv;
}