'use strict';
import { debug } from '@mangos/debug';
import { fmod } from '../r-func.mjs';
import {
    ME,
    ML_ERROR2,
    lineInfo4
} from '../../packages/common/logger.mjs';
const printer_cospi = debug('cospi');
export function cospi(x) {
    if (isNaN(x))
        return x;
    if (!isFinite(x)) {
        ML_ERROR2(ME.ME_DOMAIN, lineInfo4, printer_cospi);
        return NaN;
    }
    x = fmod(Math.abs(x), 2);
    if (fmod(x, 1) === 0.5)
        return 0;
    if (x === 1)
        return -1;
    if (x === 0)
        return 1;
    return Math.cos(Math.PI * x);
}