import { debug } from '@mangos/debug';
import { fmod } from '../r-func.mjs';
import {
    ME,
    ML_ERROR2
} from '../../packages/common/logger.mjs';
const printer_sinpi = debug('sinpi');
export function sinpi(x) {
    if (isNaN(x))
        return x;
    if (!isFinite(x)) {
        ML_ERROR2(ME.ME_DOMAIN, 'sinpi not finite', printer_sinpi);
        return NaN;
    }
    x = fmod(x, 2);
    if (x <= -1)
        x += 2;
    else if (x > 1)
        x -= 2;
    if (x === 0 || x === 1)
        return 0;
    if (x === 0.5)
        return 1;
    if (x === -0.5)
        return -1;
    return Math.sin(Math.PI * x);
}