'use strict';
import { debug } from '@mangos/debug';
import {
    fmod,
    atan,
    tan
} from '../r-func.mjs';
import {
    ME,
    ML_ERROR2,
    lineInfo4
} from '../../packages/common/logger.mjs';
const printer_tanpi = debug('tanpi');
export function tanpi(x) {
    if (isNaN(x))
        return x;
    if (!isFinite(x)) {
        ML_ERROR2(ME.ME_DOMAIN, lineInfo4, printer_tanpi);
        return NaN;
    }
    x = fmod(x, 1);
    if (x <= -0.5) {
        x++;
    } else if (x > 0.5) {
        x--;
    }
    return x === 0 ? 0 : x === 0.5 ? NaN : tan(Math.PI * x);
}
export function atanpi(x) {
    return atan(x) / Math.PI;
}