import { IRNG } from "./irng";
import { IRNGNormal } from "./normal/normal-rng";
import type { IRNGType } from './rng-types';
import type { IRNGNormalType } from './normal/rng-types';
import type { SampleKindType } from './sample-kind-type';
export declare function globalUni(d?: IRNG): IRNG;
export declare function globalNorm(d?: IRNGNormal): IRNGNormal;
export declare function globalSampleKind(d?: SampleKindType): SampleKindType;
export declare type RandomGenSet = {
    uniform?: IRNGType;
    normal?: IRNGNormalType;
    sampleKind?: SampleKindType;
};
export declare function setSeed(seed: number, randomSet?: RandomGenSet): void;
declare function RNGkind(opt?: RandomGenSet): RandomGenSet;
declare namespace RNGkind {
    var uniform: Record<IRNGType, IRNGType>;
    var normal: Record<IRNGNormalType, IRNGNormalType>;
    var sampleKind: Record<SampleKindType, SampleKindType>;
}
export { RNGkind };
export declare function randomSeed(internalState?: Uint32Array | Int32Array): Uint32Array | Int32Array | never;
