import type { IRNGType } from './rng-types';
import type { IRandom } from './IRandom';
export declare enum MessageType {
    INIT = "@@INIT@@"
}
export declare abstract class IRNG implements IRandom {
    protected _name: string;
    static readonly kind: IRNGType;
    private notify;
    constructor(name: string);
    get name(): string;
    randoms(n: number): Float32Array;
    random(): number;
    emit(event: MessageType, ...args: unknown[]): void;
    register<F extends (...args: any[]) => void>(event: MessageType, handler: F): void;
    unregister<F extends (...args: any[]) => void>(event: MessageType, handler?: F): void;
    abstract get seed(): Uint32Array | Int32Array;
    abstract set seed(_seed: Uint32Array | Int32Array);
    init(seed: number): void;
    abstract get cut(): number;
}
